<?php

namespace App\Data;

/**
 * information about a team member
 */
class Member {
    /**
     * @var int The member's user id
     */
    private int $userId;

    private string $email;
    /**
     * @var MemberRole the member's role
     */
    private MemberRole $role;

    /**
     * @param int $userId
     * @param string $email
     * @param MemberRole $role
     */
    public function __construct(int $userId, string $email, MemberRole $role) {
        $this->userId = $userId;
        $this->email = $email;
        $this->role = $role;
    }


    /**
     * @return int
     */
    public function getUserId(): int {
        return $this->userId;
    }

    /**
     * @return MemberRole
     */
    public function getRole(): MemberRole {
        return $this->role;
    }

    /**
     * @return string
     */
    public function getEmail(): string {
        return $this->email;
    }

}